% Frequency, Mean Square Phase and Mean Phase, mod 1 cycle, with swept frequency
%       Second-Order Loop with iterated parameters and accumulated statistics
%  SINE NONLINEARITY
%  Toolboxes Required: control
% [22,000 points/minute, 27 seconds/10000 points (sop=2 & 100 samples per point) with Athlon 3000+]
clear;
for z = 1.414 %[.5 .707 1] % variable 1 (iterated variables are commented out below)
for WdotN = .69 %[.6 .63 .66 .69] % variable 2
   fid = fopen('runrec.txt','a'); %save output in this file
   display = 1; % used to turn off first part of display after one time
   dd = 0; 
for Deginit = 0:1:359 % initial phase in degrees, variable 3, (SPACE EVENLY for histograms)    
Phinit = Deginit*pi/180; %initial phase in radians
dd = dd + 1; %simulation number
clear Fnet Fsum PDnoise er freq mnn t tshrt var varshrt 
if dd==1; Pin1=Deginit; Pin2 = Pin1; Pin3=Pin1; % first initial phase value
elseif dd==2; Pin2=Deginit-Pin1; Pin3=Pin2; % step size of initial phase
else Pin3=Deginit; %last initial phase value
end
% MODIFY PARAMETERS BELOW & GO (iterated parameters are modified above and commented out below)
%*****************************
% Set either of the following parameters and set the other to zero.
NS = .05; % N/S in Loop Bandwidth
No = 0; % Noise Power Density, per Hz, to Signal Ratio
Sources = 2; % 1 or 2 independent noise sources

% Set input phase sweep (linear frequency sweep)
%WdotN = .855; % normalized sweep rate(dWin/dt)/(Wn squared)
WstartN = -80; % initial frequency / natural frequency
%Phinit = 0;  % radian initial phase
Winit = 0; % radian/sec initial frequency of VCO (not of reference input)
Wn = 1;      % rad/sec natural frequency
%z = .707;    % damping factor
alpha = 1;   % Eq. (6.5)
SmpPerWL = 400; % ratio of sample rate to unity-gain radian bandwidth 
TshowXWL = 1; % (period between outputs) X (unity-gain radian bandwidth)
DelayStats = .8; % Delay, relative to run time, before mean square phase measurement
nmult = 0.6 + 3.6*z; ncmpo = round(-nmult*WstartN/WdotN);  % computed output points.  Optional nmult formula attempts to put zero crossing mid sweep.
Offset = 0;     % offset at PD output (same sign as steady-state output)
truncatePh = 1; % 1:truncate phase; 0:do not
Punits = 0;     % 0:radians  1:cycles  2:degrees
Funits = 0;     % 0:radians/sec   1:Hz
		% Choose Graphical Output
		%  gop=0:  No plot 
		%  gop=1:  Phase Plane = Freq. vs. Phase
		%  gop=2:  Phase Plane + Phase Error vs. Time
		%  gop=3:  Frequency + Sampler Output vs. Time
		%  gop=4:  All of above = 4 plots
		%  gop=5:  Statistical plots
		gop = 5;
Kfilt = .03; %filtered frequency is low-passed with time constant appx. 1/Kfilt (for Kfilt <<1) 
	%  sop=0:  No stats
	%  sop=1:  Compute array
	%  sop=2:  Compute running stats (no array)
	%  sop=3:  Compute array and running stats
sop = 2;  % Set sop = 2 normally.
%******************************
	if (sop == 2) && (gop > 0) && (gop < 5)
		gop = 5;
	end
    ststrt = fix(DelayStats*ncmpo);
    strtplt = ststrt + 10;

    Bn = Wn*(1/(2*z) + 2*z*alpha^2)/4; % Noise BW in Hz
    if display
        fprintf('\n\nIterative version of swp    swpi (4/13/07)')
        fprintf('\nAcquisition with a Linear Frequency Sweep')
        fprintf('\n2nd-order loop with SINUSOIDAL Phase Detector Characteristic')
        fprintf('\nWn = %g rad/sec; zeta = %g; alpha = %g',Wn,z,alpha)
        fprintf('\nNoise Bandwidth (linear), Bno = %g Hz.  Number of noise sources: %u\n',Bn,Sources)
        fprintf(fid,'\n\nIterative version of swp    swpi (12/12/04)');
        fprintf(fid,'\nAcquisition with a Linear Frequency Sweep');
        fprintf(fid,'\n2nd-order loop with SINUSOIDAL Phase Detector Characteristic');
        fprintf(fid,'\nWn = %g rad/sec; zeta = %g; alpha = %g',Wn,z,alpha);
        fprintf(fid,'\nNoise Bandwidth (linear), Bno = %g Hz.  Number of noise sources: %u\n',Bn,Sources);
    end

%Polynominals for open loop gain:
	N = [0     2*z*Wn*alpha   Wn^2]; % numerator
	D = [1   2*z*Wn*(1-alpha)   0 ]; % denominator

[a,b,c,d] = tf2ss(N,D); % elements of dynamic matrix equation
y = Phinit; % initial phase at output

%Compute unity-gain bandwidth
factor = N(2)^2-D(2)^2;
WL = sqrt((factor+sqrt(factor^2+4*N(3)^2))/2); % open-loop gain = 1

SmpRate = SmpPerWL*WL; % sample rate
OutInc = TshowXWL/WL;% period between outputs

% Compute multiplier of noise distribution having unity power.
if NS == 0,
	Dn = No; NS = Bn*Dn;
	if display
        fprintf('Noise Density to Signal Ratio = %g /Hz',No)
        fprintf(fid,'Noise Density to Signal Ratio = %g /Hz',No);
    end
else
	Dn = NS/Bn;
 	if display
       fprintf('Signal/Noise in Bno = %g',1/NS)
       fprintf(fid,'Signal/Noise in Bno = %g',1/NS);
    end
end
%fprintf('\nOffset %g = asin(%g rad)',Offset,asin(Offset))
Kn = sqrt(Dn*SmpRate/2); %Noise multiplier

last = 1 + ncmpo; % index of last output
ending = OutInc*ncmpo; % End time
SmpPerOut = SmpRate*OutInc; % samples per output period
t = linspace(0,ending,last); % linear sequence of times for plots
dt = (t(2) - t(1))/SmpPerOut; % sample time increment
if gop && (gop < 5)
	clf; % clear previous graphs
end

if NS < 0.03 % less than 2% error from this approximation or from 14 terms
    sig2 = NS;
else
    sig2 = (pi^2)/3;
    for kk = 1:14
        sig2 = sig2 +4*((-1)^kk/kk^2)*besseli(kk,1/NS)/besseli(0,1/NS);
    end % for
end % if

exph = asin(WdotN); %theoretical phase error due to sweep 
exms = sig2 + exph^2; %expected mean square phase
if display
    % To help judge inaccuracy of ignoring sampling,
    %   compute extra phase shift produced at unity gain
    SampPhShift = -(90/pi)*WL*OutInc/SmpPerOut; % radians lag from sampling at unity open-loop gain
    fprintf('\nAdded phase at unity O.L. gain due to sampling = %g deg.\n',SampPhShift)
    fprintf(fid,'\nAdded phase at unity O.L. gain due to sampling = %g deg.\n',SampPhShift);
    if truncatePh
        fprintf('Phase will be shown in range 0.5 cycle, modulo 1 cycle.\n')	
    else
        fprintf('Phase range will be unrestricted.\n')
    end
fprintf('Theoretical nonlinear variance, 1st order loop, same So2 in Bno: %g rad^2',sig2)
    fprintf('\nExpected phase due to sweep: %g rad, combining to give %g rad^2 mean square phase\n',exph, exms)
    fprintf('Variance in Bno is So2 = %g rad^2',NS)
    fprintf('\n%g displayed samples over %g seconds for each initial phase',last,last*OutInc)
    fprintf('\nMean square phase measured after %2.0f%% of run',100*DelayStats)
    fprintf('\nSweep: initial frequency %g * Wn; sweep rate %g * Wn^2.\n',WstartN,WdotN)
	rel0MT = -100*WstartN/WdotN/last/OutInc;
	relLag = 100*(1-100/(100 - rel0MT)/last/Kfilt);
	fprintf('Mistuning -> 0 at %2.0f%% of run.  Frequency -> %4.1f%% of ramp due to lowpass.\n',rel0MT,relLag)
    fprintf(fid,'Theoretical nonlinear variance, 1st order loop, same So2 in Bno: %g rad^2',sig2);
    fprintf(fid,'\nExpected phase due to sweep: %g rad, combining to give %g rad^2 mean square phase\n',exph, exms);
    fprintf(fid,'Variance in Bno is So2 = %g rad^2',NS);
    fprintf(fid,'\n%g displayed samples over %g seconds for each initial phase',last,last*OutInc);
    fprintf(fid,'\nMean square phase measured after %2.0f%% of run',100*DelayStats);
    fprintf(fid,'\nSweep: initial frequency %g * Wn; sweep rate %g * Wn^2.\n',WstartN,WdotN);
    fprintf(fid,'Mistuning -> 0 at %2.0f%% of run.  Frequency -> %4.1f%% of ramp due to lowpass.\n',rel0MT,relLag);
end

%    BEGIN SIMULATION
NL = sin(-Phinit); % <<<<<<<<<<<< THE NON-LINEARITY
% state variables to give specified initial conditions
% X2 and X3 respectively in Eq. (6.50) and (6.51) with D(3) = 0:
x0(1) = (Winit-N(2)*(NL+Offset))/(N(3)-D(2)*N(2));
x0(2) = (Phinit-N(2)*x0(1))/N(3);
e = -Phinit; % initial phase error
freq(1) = Winit; % initial frequency at output
Nplus = 0; Nminus = 0; % skipped cycles
Fsum(1) = 0; Fnet(1) = 0; % rate of skipping

if truncatePh, % truncate e range to pi % <<<<<<<<<<<<TRUNCATION
	if e>0
		e = rem(e+pi,2*pi) - pi;
	else
		e = rem(e-pi,2*pi) + pi;
	end
end % if truncatePh
ersum = 0; ersum2 = 0;
var(1) = NS; % start plot at linear value (avoid problem with ratio in dB)
if (sop ~= 2) 
	er(1) = e;
end
[Phi, Gamma] = c2d(a,b,dt); % values for use in solution eqution [see manual]

running = last; i = 1;
while running
    if (running > 10)
        Fnet(last)=0;
        Fsum(last)=0;
        PDnoise(last)=0;
        er(last)=0;
        freq(last)=0;
        mnn(last)=0;
        t(last)=0;
        tshrt(last)=0;
        var(last)=0;
        varshrt(last)=0;
    end % preassigning arrays
	while i < last, % compute loop responses
		i = i + 1;
		for j = 1:SmpPerOut, % loop through unrecorded samples
            k = (i-2)*SmpPerOut + j + 1;
			DelRad = Wn*(WstartN*k*dt + WdotN*Wn*((k*dt)^2)/2); %phase from frequency ramp
            e = DelRad - y; % untruncated error
			NL = sin(e); % <<<<<<<<<<<< THE NON-LINEARITY 
			if Sources == 2,
                Noise1 = randn; Noise2 = randn;
                PDn = Kn*(Noise1*sin(y)+Noise2*cos(y));
            else
                PDn = Kn*randn;
            end
			u1(1) = NL + Offset + PDn; % initial input to sampler
			u1(2) = u1(1); %  constant Hold output -> same at beginning and end of dt
			x = ltitr(Phi,Gamma,u1',x0); % solutions at period start and end [see manual] 
			yy = c*x'; % corresponding outputs (d is null for polynominals above)
			y = yy(2); % output at end of period is needed
			x0 = x(2,:)'; % final condition gives initial condition for next step
            eu = -y/(2*pi);
			if eu - Nplus + Nminus > 1
				Nplus = fix(eu + Nminus);
			elseif eu - Nplus + Nminus < -1
				Nminus = -fix(eu - Nplus);
			end
		end % for j			
        PDnoise(i) = PDn;
		if truncatePh, % truncate e range to pi % <<<<<<<<<<<<TRUNCATION
			if e>0
				e = rem(e+pi,2*pi) - pi;
			else
				e = rem(e-pi,2*pi) + pi;
			end
		end % if truncatePh
		if (sop ~= 2)
            er(i) = e;
		end
	if ((sop == 2)||(sop == 3))&&(i>ststrt)
			ersum = ersum + e;
			ersum2 = ersum2 + e^2;
			var(i) = ersum2/(i-ststrt);
			mnn(i) = ersum/(i-ststrt);
			Fsum(i) = (Nplus + Nminus)/(dt*(i-1));
			Fnet(i) = (Nplus - Nminus)/(dt*(i-1));
		end
		% corresponding frequency out from Eq. (6.43) with d3 = 0
		freq(i) = N(2)*u1(2) + x0(1)*(N(3)-N(2)*D(2)); 
	end % for i
	
	% END SIMULATION.  The rest is plotting.
	
	clf;
    ncmpo = last - 1;
	ending = ncmpo*OutInc;
	t = linspace(0,ending,last); % reestablish time vector

%****** Start Response Plots for Diagnostics Use	
	if Punits == 1,
		Pscale = 1/(2*pi);
	elseif Punits == 2,
		Pscale = 180/pi;
    else
		Pscale = 1;
	end % if Punits
	
	if Funits == 1,
		Fscale = 1/(2*pi);
	else
		Fscale = 1;
	end % if Funits
	
	if (gop > 0)&&(gop < 5)
		if (gop == 1)||(gop == 2)||(gop == 4), % selecting phase-plane plot
			if gop==1,
				subplot(111),
			elseif gop==2,
				subplot(211),
			elseif gop==4,
				subplot(221),
			end % if gop==1
			plot(Pscale*(er),Fscale*freq,'r')
			title('Phase Plane, Nonlinear Simulation')
			grid
			if Punits == 1, % Set display of phase units
				xlabel('phase error (cycles)');
			elseif Punits == 2,
				xlabel('phase error (degrees)');
            else
				xlabel('phase error (radians)')
			end % if Punits
			if Funits == 1, % Set display of frequency units
				ylabel('freq. out (Hz)');
            else
			 ylabel('freq. out (rad/sec)');
			end % if Funits
		end % if gop ~= 0 or 3
		
		if (gop == 2)||(gop == 4), % selecting phase error vs. time
			if gop == 2,
				subplot (212),
            else
				subplot (223),
			end % if gop==2
			plot(t,Pscale*er,'g')
			title('Phase Error')
			grid
			xlabel('seconds')
			if Punits == 1, % Set display of phase units
				ylabel('cycles');
			elseif Punits == 2,
				ylabel('degrees');
            else
				ylabel('radians');
			end % if Punits
		end % if ()|()
		
		if (gop == 3)||(gop == 4), 
			if gop == 3, % selecting frequency vs. time
				subplot(211);
            else
				subplot(222),
			end % if gop==3 
			plot(t,Fscale*freq,'b')
			title('Frequency Out')
			grid
			xlabel('seconds');
			if Funits == 1, % Set display of frequency units
				ylabel('Hz');
            else
			 ylabel('radians / second');
			end % if Funits
		
			if gop == 3, % selecting Filtered Frequency vs. time
				subplot(212);
            else
				subplot(224),
			end % if gop==3 
            for ii = 2:i % filtering of filtered frequency output
                freq(ii) = Kfilt*freq(ii) + (1-Kfilt)*freq(ii-1);
            end
            tzero = -WstartN/WdotN; Fhi = WdotN*(t(last)-tzero); % nominal zero-crossing time
			plot(t,Fscale*freq,[tzero t(last)],Fscale*[0 Fhi],'m') % plot filtered freq & nominal value
			title('Filtered Frequency');
			grid
            legend('simulated','nominal',0)
			xlabel('seconds')
		end % if ()|()
    elseif (gop == 5)&&((sop == 2)||(sop == 3))
        %****** Start Statistical Plots
        warst = warning('off','all');
        tshrt = t(strtplt:last); varshrt = var(strtplt:last);
        subplot(221);
        plot([0 t(last)],[exms exms],'g',[0 t(last)],[3.29 3.29],'m',tshrt,varshrt,'r')
        title('Phase, last part of run')
        ylabel ('mean square phase (rad^2)')
        grid on
        legend('1st-ord. theory','uniform dist.','measured',0)
        subplot(222);
        for ii = 2:i
            freq(ii) = Kfilt*freq(ii) + (1-Kfilt)*freq(ii-1);
        end
        tzero = -WstartN/WdotN; % nominal zero-crossing time 
        Fhi = WdotN*(t(last)-tzero); % last frequency, theoretical
        plot(t,Fscale*freq,[tzero t(last)],Fscale*[0 Fhi],'m') % plot filtered freq & nominal value
        title('Filtered Frequency');
        grid on
        legend('sim.','nom.',0)
        xlabel('seconds')
        if Funits == 1, % Set display of frequency units
            ylabel('Hz');
        else
            ylabel('radians / second');
        end % if Funits
        subplot(223);
		plot(tshrt,mnn(strtplt:last),'k',[0 t(last)],[exph exph],'b')
		title('mean phase error (rad)')
		grid on
        legend('mean ph.','expected',0)
		subplot(224);
		plot([0 1 1],[0 0 1])
		title('Parameters')
        text(.05,.8,horzcat('Sweep Rate: ',num2str(WdotN),' Wn^2'))
        text(.05,.6,horzcat('Variance: ',num2str(NS),' rad^2'))
        text(.05,.4,horzcat('Init. Freq.: ',num2str(WstartN),' Wn'))
        text(.05,.2,horzcat('Init. Deg.: ',num2str(Deginit),' deg.'))
        warning(warst);
    end % plotting
	
	if (sop == 1)||(sop == 3) % compute from array
        fprintf('\nEstimate from error array:')
        arvar = std(er)^2;
        logarvar = 10*log10(arvar/exms);
        fprintf('\n  output variance %g rad^2\n  ratio to So2 %g dB',arvar,logarvar);
        armnn = mean(er);
        fprintf('\n  mean phase error %g rad\n  %g points including initial phase\n',armnn,last);
	end % for error array stats
    
	if (sop == 2)||(sop == 3) % compute from running stats
%       logvar = 10*log10(var(last)/exms); logmn = 10*log10(mnn(last)/exph);
%       fprintf('\n  For last half of run:')
        display = 0;
%       fprintf(' Initial phase %g deg.\n',Deginit);
%       fprintf(' Initial phase %g deg.\n  mean square phase %g rad^2;  ratio to "expected" %g dB',Deginit,var(last),logvar);
%		fprintf('\n  mean phase error %g rad; ratio to expected %g dB\n  %g points (%g seconds);',mnn(last),logmn,last,last*OutInc);
%       fprintf(' %g skipped cycles with %g net
%       skips\n',Nplus+Nminus,Nplus-Nminus);
    end % for running stats
	
    pause(1)
	running = 0;
end % while running
% gather statistics from each simulation
ZPhi(dd) = Deginit; Zvar(dd) = var(last); Zavg(dd) = mnn(last); Zfreq(dd) = freq(i)/Fhi;
end % for Phinit
if sop
    if Pin2 < Pin3
        [fcnt, fval] = hist(Zfreq);
        fcnt = 100*fcnt/(1+(Pin3-Pin1)/Pin2);
        subplot(224);
        warst = warning('off','all');
        bar(fval, fcnt)
        title('Filtered Frequency at end')
        xlabel('ratio to undelayed at end')
        ylabel('%')
        [pcnt, pval] = hist(Zvar);
        pcnt = 100*pcnt/(1+(Pin3-Pin1)/Pin2);
        subplot(223);
        bar(pval,pcnt)
        title('Phase (last part of run)')
        xlabel('mean square value (rad^2)')
        ylabel('%')
        %iip = 0; for ip=Pin1:Pin2:Pin3; iip = iip + 1; Pinit(iip)=ip;end
        subplot(222);
        bar(Zfreq);
        title('Relative Frequency')
        xlabel('run #')
        ylabel('ratio')
        grid
        subplot(221);
        bar(Zvar)
        title('Mean Square Phase')
        xlabel('run #')
        ylabel('rad^2')
        grid
        warning(warst);
        for i = 1:10
            pcntr(i) = pcnt(11-i);
            pvalr(i) = pval(11-i);
        end
      
        pause(1)
        fprintf('                                    expect %1.4f (random -> 3.29 rad^2)\n',exms);
        fprintf('relative frequency    %%    integ.        rad^2          %%    integ.\n');
        fprintf(fid,'relative frequency    %%    integ.        rad^2          %%    integ. (rad^2: random 3.29, expect %1.4f)\n',exms);
        fcwas = 0; pcwas = 0; fcint = 100; pcint = 100;
        fhfstp = (fval(2) - fval(1))/2; phfstp = (pvalr(2)-pvalr(1))/2;
        for ip = 1:10
            fcnta = fcnt(ip); pcnta = pcntr(ip); 
            fcint = fcint - fcwas; pcint = pcint - pcwas;      
            fprintf('%7.4f ->%7.4f %7.2f %7.2f %7.4f ->%7.4f %7.2f %7.2f\n',fval(ip)-fhfstp,fval(ip)+fhfstp,fcnta,fcint,pvalr(ip)-phfstp,pvalr(ip)+phfstp,pcnta,pcint);
            fprintf(fid,'%7.4f ->%7.4f %7.2f %7.2f %7.4f ->%7.4f %7.2f %7.2f\n',fval(ip)-fhfstp,fval(ip)+fhfstp,fcnta,fcint,pvalr(ip)-phfstp,pvalr(ip)+phfstp,pcnta,pcint);
            fcwas = fcnta; pcwas = pcnta;
        end
    end % Pin2 < Pin3
 %g   fprintf('%g to %g deg. in %g deg. increments.\n',Pin1,Pin2,Pin3)
    fprintf('Init. Deg.:');for ip=Pin1:Pin2:Pin3; fprintf('%7.1f',ip);end
    fprintf('\nRel. Freq.:');fprintf('%7.3f',Zfreq)
    fprintf('\nM.S. Phase:');fprintf('%7.3f',Zvar) 
    fprintf('\n         ');[jkx jkm]=size(Zvar);for jk=1:jkm;fprintf('%7.0f',jk);end
    fprintf(fid,'Init. Deg.:');for ip=Pin1:Pin2:Pin3; fprintf(fid,'%7.1f',ip);end
    fprintf(fid,'\nRel. Freq.:');fprintf(fid,'%7.3f',Zfreq);
    fprintf(fid,'\nM.S. Phase:');fprintf(fid,'%7.3f',Zvar);
    fprintf(fid,'\n         ');[jkx jkm]=size(Zvar);for jk=1:jkm;fprintf(fid,'%7.0f',jk);end

    sound(sin(6283*[0:1/8192:0.2]),8192); %0.2 seconds of 1 kHz tone;
end % for variable 3
fclose(fid);
end % for variable 2
end % for variable 1
